VERSION 5.00
Begin VB.Form DNA 
   BackColor       =   &H00000000&
   Caption         =   "3D DNA (Right click for options)"
   ClientHeight    =   6045
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4785
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   403
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   319
End
Attribute VB_Name = "DNA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim Lines() As SuperLine
Dim Buffer As Buffer
Dim BW%, Pen As Long, lFart As Double
Dim lSov As Integer, lColorA As Long, lColorB As Long, lC$
Dim X%, Y%, lAtomWidth As Integer, lAngle As Double
Dim lListIndex%, lLineSpace As Double, lDegrees As Integer
Dim lExitLoop As Boolean, lDNAWidth As Integer, HMax As Double
Dim lNumberOfLines As Integer, TableX(3600) As Double, TableY(3600) As Double

Private Sub Form_Load()

Dim hSysMenu As Long, nCnt As Long

BW = Me.ScaleWidth / 2
Dialog.Icon = DNA.Icon

lColorA = GetSetting("DNA", "Options", "ColorA", vbRed)
lColorB = GetSetting("DNA", "Options", "ColorB", vbBlue)
lFart = GetSetting("DNA", "Options", "Speed", 1)
lSov = GetSetting("DNA", "Options", "Sleep", 0)
C = GetSetting("DNA", "Options", "Option", 0)
lAtomWidth = GetSetting("DNA", "Options", "Atom", 3)
lListIndex = GetSetting("DNA", "Options", "ListIndex", 0)
lLineSpace = GetSetting("DNA", "Options", "LineSpace", 7)
lDegrees = GetSetting("DNA", "Options", "Degrees", 10)
lDNAWidth = GetSetting("DNA", "Options", "DNAWidth", 50)
lAngle = GetSetting("DNA", "Options", "Angle", 15) * 3
lNumberOfLines = GetSetting("DNA", "Options", "NumberOfLines", 50)

ReDim Lines(lNumberOfLines)
SetColors True

Dialog.LoadThing
ReVarTable

CreateBuffer

Me.Left = GetSetting("DNA", "Position", "X", (Screen.Width / 2) - Me.Width)
Me.Top = GetSetting("DNA", "Position", "Y", (Screen.Height / 2) - Me.Height)
Me.Width = GetSetting("DNA", "Position", "Width", 4890)
Me.Height = GetSetting("DNA", "Position", "Height", 6555)
Me.WindowState = GetSetting("DNA", "Position", "WindowState", 0)

' Deleting the X-Button in about:
hSysMenu = GetSystemMenu(About.hwnd, False)
If hSysMenu Then
nCnt = GetMenuItemCount(hSysMenu)
If nCnt Then
RemoveMenu hSysMenu, nCnt - 1, MF_BYPOSITION Or MF_REMOVE
RemoveMenu hSysMenu, nCnt - 2, MF_BYPOSITION Or MF_REMOVE
DrawMenuBar About.hwnd
End If
End If

StartDoLoop

End Sub

Sub CreateBuffer()

Buffer.hdc = CreateCompatibleDC(Me.hdc)
Buffer.Image = CreateCompatibleBitmap(Me.hdc, Me.ScaleWidth, Me.ScaleHeight)
Buffer.SelectLong = SelectObject(Buffer.hdc, Buffer.Image)
Buffer.ScaleWidth = Me.ScaleWidth
Buffer.ScaleHeight = Me.ScaleHeight

End Sub

Sub DeleteBuffer()

DeleteDC Buffer.hdc
DeleteObject Buffer.Image

End Sub

Sub SetColors(ChangeDegree As Boolean)

Dim A%, B%, C#
For A = 0 To UBound(Lines)

If ChangeDegree = True Then
B = B + lDegrees
If B >= 360 Then B = B - 360

Lines(A).Degree = B
End If

C = (255 / UBound(Lines))

Select Case lListIndex
Case 0: Lines(A).Color = RGB(255 - (A * C), 0, A * C)
Case 1: Lines(A).Color = RGB(255 - (A * C), A * C, 0)
Case 2: Lines(A).Color = RGB(255, A * C, 0)
Case 3: Lines(A).Color = RGB(255, 0, A * C)
Case 4: Lines(A).Color = RGB(255, A * C, A * C)
Case 5: Lines(A).Color = vbRed
Case 6: Lines(A).Color = RGB(A * C, 0, 255 - (A * C))
Case 7: Lines(A).Color = RGB(A * C, 0, 255)
Case 8: Lines(A).Color = RGB(0, A * C, 255)
Case 9: Lines(A).Color = RGB(0, A * C, 255 - (A * C))
Case 10: Lines(A).Color = RGB(A * C, A * C, 255)
Case 11: Lines(A).Color = vbBlue
Case 12: Lines(A).Color = RGB(A * C, 255, 0)
Case 13: Lines(A).Color = RGB(A * C, 255 - (A * C), 0)
Case 14: Lines(A).Color = RGB(0, 255, A * C)
Case 15: Lines(A).Color = RGB(0, 255 - (A * C), A * C)
Case 16: Lines(A).Color = RGB(A * C, 255, A * C)
Case 17: Lines(A).Color = vbGreen
End Select

Next

End Sub

Sub DrawLine(Degrees As Double, Y As Integer, Color As Long)

Dim A%
A = Degrees + 180
If A > 360 Then A = A - 360

Pen = CreatePen(0, lAtomWidth, lColorA)
SelectObject Buffer.hdc, Pen
MoveToEx Buffer.hdc, BW + TableX(Degrees * 10), Y + TableY(Degrees * 10), ByVal 0
LineTo Buffer.hdc, BW + TableX(Degrees * 10) + 1, Y + TableY(Degrees * 10) + 1
DeleteObject Pen

Pen = CreatePen(0, lAtomWidth, lColorB)
SelectObject Buffer.hdc, Pen
MoveToEx Buffer.hdc, BW + TableX(A * 10), Y + TableY(A * 10), ByVal 0
LineTo Buffer.hdc, BW + TableX(A * 10), Y + TableY(A * 10)
DeleteObject Pen

Pen = CreatePen(0, 1, Color)
SelectObject Buffer.hdc, Pen

MoveToEx Buffer.hdc, BW + TableX(A * 10), Y + TableY(A * 10), ByVal 0
LineTo Buffer.hdc, BW + TableX(Degrees * 10), Y + TableY(Degrees * 10)

DeleteObject Pen

End Sub

Public Sub ExitLoop()

lExitLoop = True

End Sub

Public Sub StartDoLoop()

Dim A%, B%, C As Double

Show

Do Until lExitLoop
If Dialog.Option1(1).Value = True Then lColorA = Rnd * vbWhite: lColorB = Rnd * vbWhite
BitBlt Buffer.hdc, 0, 0, Buffer.ScaleWidth, Buffer.ScaleHeight, 0, 0, 0, vbWhiteness

B = UBound(Lines) * lLineSpace / 2
C = Sin(Degree(lAngle))

For A = 0 To UBound(Lines)
Lines(A).Degree = Lines(A).Degree + lFart
If Lines(A).Degree >= 360 Then Lines(A).Degree = Lines(A).Degree - 360

DrawLine Lines(A).Degree, ((A * lLineSpace) + 20) + (C * (B - (A * lLineSpace))), Lines(A).Color
Next

BitBlt Me.hdc, X, Y, Buffer.ScaleWidth, Buffer.ScaleHeight, Buffer.hdc, 0, 0, vbSrcCopy
If Not lSov = 0 Then Sleep lSov

DoEvents
Loop

lExitLoop = False

End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

If Button = 2 Then
Dialog.Show
Dialog.LoadThing
End If

End Sub

Private Sub Form_Resize()

X = (Me.ScaleWidth / 2) - (Buffer.ScaleWidth / 2)
Y = (Me.ScaleHeight / 2) - (Buffer.ScaleHeight / 2)

BitBlt Me.hdc, 0, 0, Me.ScaleWidth, Me.ScaleHeight, 0, 0, 0, vbWhiteness

End Sub

Private Sub Form_Unload(Cancel As Integer)

DeleteBuffer

SaveSetting "DNA", "Position", "X", Me.Left
SaveSetting "DNA", "Position", "Y", Me.Top
SaveSetting "DNA", "Position", "Width", Me.Width
SaveSetting "DNA", "Position", "Height", Me.Height
SaveSetting "DNA", "Position", "WindowState", Me.WindowState

Unload DNA
End

End Sub

Public Sub ReVarTable()
Dim A#
For A = 0 To 3600
TableX(A) = Sin(Degree(A / 10)) * lDNAWidth
TableY(A) = Cos(Degree(A / 10)) * HMax
Next
End Sub

Public Sub SetColor(Color As Long, Index As Integer)
If Index = 0 Then lColorA = Color
If Index = 1 Then lColorB = Color
End Sub

Public Function GetColor(Index As Integer) As Long
If Index = 0 Then GetColor = lColorA
If Index = 1 Then GetColor = lColorB
End Function

Public Property Get Fart() As Double
Fart = lFart
End Property

Public Property Let Fart(ByVal vNewValue As Double)
lFart = vNewValue
End Property

Public Property Get Sov() As Integer
Sov = lSov
End Property

Public Property Let Sov(ByVal vNewValue As Integer)
lSov = vNewValue
End Property

Public Property Get C() As String
C = lC
End Property

Public Property Let C(ByVal vNewValue As String)
lC = vNewValue
End Property

Public Property Get Atom() As Integer
Atom = lAtomWidth
End Property

Public Property Let Atom(ByVal vNewValue As Integer)
lAtomWidth = vNewValue
End Property

Public Property Get Angle() As Double
Angle = lAngle / 3
End Property

Public Property Let Angle(ByVal vNewValue As Double)
lAngle = vNewValue * 3
HMax = Sin(Degree(lAngle)) * lDNAWidth
ReVarTable
End Property

Public Property Get ListIndex() As Integer
ListIndex = lListIndex
End Property

Public Property Let ListIndex(ByVal vNewValue As Integer)
lListIndex = vNewValue
SetColors False
End Property

Public Property Get LineSpace() As Double
LineSpace = lLineSpace
End Property

Public Property Let LineSpace(ByVal vNewValue As Double)
lLineSpace = vNewValue
End Property

Public Property Get Degrees() As Integer
Degrees = lDegrees
End Property

Public Property Let Degrees(ByVal vNewValue As Integer)
lDegrees = vNewValue
SetColors True
End Property

Public Property Get DNAWidth() As Integer
DNAWidth = lDNAWidth
End Property

Public Property Let DNAWidth(ByVal vNewValue As Integer)
lDNAWidth = vNewValue
HMax = Sin(Degree(lAngle)) * lDNAWidth
ReVarTable
End Property

Public Property Get NumberOfLines() As Integer
NumberOfLines = lNumberOfLines
End Property

Public Property Let NumberOfLines(ByVal vNewValue As Integer)
lNumberOfLines = vNewValue
ReDim Lines(lNumberOfLines)
SetColors True
End Property
